
enum gpc_enum_queue_types {
 GPC_QTYPE_LOCAL = 0,
 GPC_QTYPE_REMOTE,
 GPC_QTYPE_DIRECT,
 GPC_QTYPE_SMB,
 GPC_QTYPE_NCP,
 GPC_QTYPE_UNKNOWN
};

typedef struct 
{
 char *printer_model;
 
 char *gs_dev;
 
 char *res;
 char *size;
 char *bpp;

 char *margin_right_left;
 char *margin_top_bottom;

 char *pages_per_page;
 
 unsigned int send_eof : 1;
 unsigned int fix_stair_text : 1;
 unsigned int fast_text : 1;

 char *gs_opts;
} GPC_FILTER_SELECTION;

typedef struct
{
 /* char *qname; */
 int qtype;
 int ref;
 char **qlist;
 char *spool_dir;
 int file_limit;
 char *ifilter;
 char *acct_file;
 char *ofilter;      
 /*  void * qinfo; */
 /* GPC_FILTER_INFO * filter_info; */
 
 /* Local Connection */
 char *local_device;
 
 /* Remote Connection */
 char *remote_host;
 char *remote_queue;
 
 /* SMB Connection */
 char *SMB_host;
 char *SMB_ip;
 char *SMB_printer_name;
 char *SMB_workgroup;
 
 /* used for both ncp and smb printers */
 char *user; 
 char *passwd; 
 
 /* NCP Connection */
 char *NCP_printserver_name;
 char *NCP_queue_name;
 
 /* Direct Connection */
 char *direct_host;
 int direct_port;

 unsigned int suppress_headers : 1;
 
 GPC_FILTER_SELECTION *filter_opts;
} GPC_QUEUE_INFO;

/* This structure represents one printer with the supporting 
   detail stuck in qinfo. This is in contrast to the other
   possible interpretation where qinfo is a vector to all printers
*/
typedef struct {
 char *qname; /* this is a duplication of the qinfo->qname */
 GPC_QUEUE_INFO *qinfo;
} GPC_QUEUE_LIST;

extern void gpc__queue_free_filter_opts(GPC_FILTER_SELECTION *);
extern GPC_QUEUE_LIST **gpc_queue_get_list(char *filename);
extern void gpc_queue_free_list(GPC_QUEUE_LIST **qlist);
extern GPC_QUEUE_INFO *gpc_queue_get_info (char *queue_name);
extern void gpc_queue_free_info(GPC_QUEUE_INFO *qinfo);
extern GPC_QUEUE_LIST **gpc_queue_add(GPC_QUEUE_LIST **, GPC_QUEUE_INFO *);
extern GPC_QUEUE_LIST **gpc_queue_edt(GPC_QUEUE_LIST **, GPC_QUEUE_INFO *);
extern GPC_QUEUE_LIST **gpc_queue_del(GPC_QUEUE_LIST **, char *);
extern int gpc_queue_save_printer(GPC_QUEUE_INFO *);

extern char *gpc_queue_names(GPC_QUEUE_INFO *);
extern GPC_QUEUE_LIST **gpc_queue_alias(GPC_QUEUE_LIST **, GPC_QUEUE_INFO *,
                                        char *);
